## stfl 0.15

=== Makefile ===
#
#  STFL - The Structured Terminal Forms Language/Library
#  Copyright (C) 2006, 2007  Clifford Wolf <clifford@clifford.at>
#
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 3 of the License, or (at your option) any later version.
#  
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#  MA 02110-1301 USA
#

include Makefile.cfg

export CC = gcc
export CFLAGS += -I. -Wall -Os -ggdb -D_GNU_SOURCE -fPIC
export LDLIBS += -lncursesw

all: libstfl.a example

example: libstfl.a example.o

libstfl.a: public.o base.o parser.o dump.o style.o binding.o iconv.o \
           $(patsubst %.c,%.o,$(wildcard widgets/*.c))
	rm -f $@
	ar qc $@ $^
	ranlib $@

clean:
	rm -f libstfl.a example core core.* *.o Makefile.deps
	rm -f widgets/*.o spl/mod_stfl.so spl/example.db
	cd perl5 && perl Makefile.PL && make clean && rm -f Makefile.old
	rm -f perl5/stfl_wrap.c perl5/stfl.pm perl5/build_ok
	rm -f python/stfl.py python/stfl.pyc python/_stfl.so 
	rm -f python/stfl_wrap.c python/stfl_wrap.o
	rm -f ruby/Makefile ruby/stfl_wrap.c ruby/stfl_wrap.o
	rm -f ruby/stfl.so ruby/build_ok Makefile.deps_new

Makefile.deps: *.c widgets/*.c *.h
	$(CC) -I. -MM *.c > Makefile.deps_new
	$(CC) -I. -MM widgets/*.c | sed -r 's,^wt_[^ ]*\.o: ,widgets/&,' >> Makefile.deps_new
	mv -f Makefile.deps_new Makefile.deps

install: all
	mkdir -p $(DESTDIR)$(prefix)/lib
	mkdir -p $(DESTDIR)$(prefix)/include
	install -m 644 libstfl.a $(DESTDIR)$(prefix)/lib/
	install -m 644 stfl.h $(DESTDIR)$(prefix)/include/

ifeq ($(FOUND_SPL),1)
include spl/Makefile.snippet
endif

ifeq ($(FOUND_SWIG)$(FOUND_PERL5),11)
include perl5/Makefile.snippet
endif

ifeq ($(FOUND_SWIG)$(FOUND_PYTHON),11)
include python/Makefile.snippet
endif

ifeq ($(FOUND_SWIG)$(FOUND_RUBY),11)
include ruby/Makefile.snippet
endif

.PHONY: all clean install install_spl

include Makefile.deps

## stfl 0.18

=== Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 include Makefile.cfg
 
-export CC = gcc
+export CC = gcc -pthread
 export CFLAGS += -I. -Wall -Os -ggdb -D_GNU_SOURCE -fPIC
 export LDLIBS += -lncursesw
 
@@ -46,7 +46,7 @@
 
 Makefile.deps: *.c widgets/*.c *.h
 	$(CC) -I. -MM *.c > Makefile.deps_new
-	$(CC) -I. -MM widgets/*.c | sed -r 's,^wt_[^ ]*\.o: ,widgets/&,' >> Makefile.deps_new
+	$(CC) -I. -MM widgets/*.c | sed 's,^wt_[^ ]*\.o: ,widgets/&,' >> Makefile.deps_new
 	mv -f Makefile.deps_new Makefile.deps
 
 install: all

## stfl 0.20

=== Makefile ===
--- 
+++ 
@@ -24,6 +24,8 @@
 export CFLAGS += -I. -Wall -Os -ggdb -D_GNU_SOURCE -fPIC
 export LDLIBS += -lncursesw
 
+VERSION := 0.20
+
 all: libstfl.a example
 
 example: libstfl.a example.o
@@ -43,17 +45,22 @@
 	rm -f python/stfl_wrap.c python/stfl_wrap.o
 	rm -f ruby/Makefile ruby/stfl_wrap.c ruby/stfl_wrap.o
 	rm -f ruby/stfl.so ruby/build_ok Makefile.deps_new
+	rm -f stfl.pc
 
 Makefile.deps: *.c widgets/*.c *.h
 	$(CC) -I. -MM *.c > Makefile.deps_new
 	$(CC) -I. -MM widgets/*.c | sed 's,^wt_[^ ]*\.o: ,widgets/&,' >> Makefile.deps_new
 	mv -f Makefile.deps_new Makefile.deps
 
-install: all
-	mkdir -p $(DESTDIR)$(prefix)/lib
+install: all stfl.pc
+	mkdir -p $(DESTDIR)$(prefix)/lib/pkgconfig
 	mkdir -p $(DESTDIR)$(prefix)/include
 	install -m 644 libstfl.a $(DESTDIR)$(prefix)/lib/
 	install -m 644 stfl.h $(DESTDIR)$(prefix)/include/
+	install -m 644 stfl.pc $(DESTDIR)$(prefix)/lib/pkgconfig/
+
+stfl.pc: stfl.pc.in
+	sed 's,@VERSION@,$(VERSION),g' < $< | sed 's,@PREFIX@,$(prefix),g' > $@
 
 ifeq ($(FOUND_SPL),1)
 include spl/Makefile.snippet

## stfl 0.21

=== Makefile ===
--- 
+++ 
@@ -24,9 +24,10 @@
 export CFLAGS += -I. -Wall -Os -ggdb -D_GNU_SOURCE -fPIC
 export LDLIBS += -lncursesw
 
-VERSION := 0.20
+SONAME  := libstfl.so.0
+VERSION := 0.21
 
-all: libstfl.a example
+all: libstfl.so.$(VERSION) libstfl.a example
 
 example: libstfl.a example.o
 
@@ -35,6 +36,10 @@
 	rm -f $@
 	ar qc $@ $^
 	ranlib $@
+
+libstfl.so.$(VERSION): public.o base.o parser.o dump.o style.o binding.o iconv.o \
+                       $(patsubst %.c,%.o,$(wildcard widgets/*.c))
+	$(CC) -shared -Wl,-soname,$(SONAME) -o $@ $^
 
 clean:
 	rm -f libstfl.a example core core.* *.o Makefile.deps
@@ -45,7 +50,7 @@
 	rm -f python/stfl_wrap.c python/stfl_wrap.o
 	rm -f ruby/Makefile ruby/stfl_wrap.c ruby/stfl_wrap.o
 	rm -f ruby/stfl.so ruby/build_ok Makefile.deps_new
-	rm -f stfl.pc
+	rm -f stfl.pc libstfl.so libstfl.so.*
 
 Makefile.deps: *.c widgets/*.c *.h
 	$(CC) -I. -MM *.c > Makefile.deps_new
@@ -53,11 +58,13 @@
 	mv -f Makefile.deps_new Makefile.deps
 
 install: all stfl.pc
-	mkdir -p $(DESTDIR)$(prefix)/lib/pkgconfig
+	mkdir -p $(DESTDIR)$(prefix)/$(libdir)/pkgconfig
 	mkdir -p $(DESTDIR)$(prefix)/include
-	install -m 644 libstfl.a $(DESTDIR)$(prefix)/lib/
+	install -m 644 libstfl.a $(DESTDIR)$(prefix)/$(libdir)
 	install -m 644 stfl.h $(DESTDIR)$(prefix)/include/
-	install -m 644 stfl.pc $(DESTDIR)$(prefix)/lib/pkgconfig/
+	install -m 644 stfl.pc $(DESTDIR)$(prefix)/$(libdir)/pkgconfig/
+	install -m 644 libstfl.so.$(VERSION) $(DESTDIR)$(prefix)/$(libdir)
+	ln -fs libstfl.so.$(VERSION) $(DESTDIR)$(prefix)/$(libdir)/libstfl.so
 
 stfl.pc: stfl.pc.in
 	sed 's,@VERSION@,$(VERSION),g' < $< | sed 's,@PREFIX@,$(prefix),g' > $@

## stfl 0.22

=== Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 export LDLIBS += -lncursesw
 
 SONAME  := libstfl.so.0
-VERSION := 0.21
+VERSION := 0.22
 
 all: libstfl.so.$(VERSION) libstfl.a example
 
@@ -39,7 +39,7 @@
 
 libstfl.so.$(VERSION): public.o base.o parser.o dump.o style.o binding.o iconv.o \
                        $(patsubst %.c,%.o,$(wildcard widgets/*.c))
-	$(CC) -shared -Wl,-soname,$(SONAME) -o $@ $^
+	$(CC) -shared -Wl,-soname,$(SONAME) -o $@ $(LDLIBS) $^
 
 clean:
 	rm -f libstfl.a example core core.* *.o Makefile.deps

=== debian/changelog ===
stfl (0.22-5) unstable; urgency=medium

  * QA upload.
  * Build with "Rules-Requires-Root: no" (Closes: #1089442)

 -- Alexandre Detiste <tchet@debian.org>  Mon, 09 Dec 2024 15:07:16 +0100

stfl (0.22-4) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.9.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files.
  * Bump debhelper from deprecated 7 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Replaced obsolete libncursesw5-dev build dependency with libncurses-dev.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 10 Oct 2024 01:40:34 +0200

stfl (0.22-3) unstable; urgency=medium

  * QA upload.
  * Fix "missing required debian/rules targets build-arch and/or build-
    indep": Add missing targets.
    (Closes: #998929)
  * debian/rules: make usage of perl's $Config{vendorarch}
    cross-build-compatible.
  * debian/control: remove Section extra for transitional packages.
    Should be optional now, which is the same as in the source stanza.
  * Remove debian/libstfl0.post{install,rm}.
    The ldconfig call happens via a trigger which is generated by debhelper.
  * Remove trailing whitespace from debian/*.

 -- gregor herrmann <gregoa@debian.org>  Sat, 25 Dec 2021 19:09:01 +0100

stfl (0.22-2) unstable; urgency=medium

  * QA upload.
  * Drop python-stfl package, unused and python2 only; Closes: #938570
  * debian/control
    - drop Vcs* fields, were still pointint to alioth
    - set maintainer to the QA team

 -- Sandro Tosi <morph@debian.org>  Sun, 29 Sep 2019 15:46:30 -0400

stfl (0.22-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "build-depends on spl-dev which is gone from the archive":
    - d/control: Drop the libstfl-spl binary package.
    - d/control: Drop spl-dev from build-depends.
    - d/libstfl-spl.*: Remove.
    - d/rules: Set 'FOUND_SPL' to '0'.
    (Closes: #805366)

 -- Unit 193 <unit193@ubuntu.com>  Wed, 09 Dec 2015 01:15:13 -0500

stfl (0.22-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix "hardcodes /usr/lib/perl5":
    - remove debian/libstfl-perl.dirs, not needed
    - create debian/libstfl-perl.install during build, using
      $Config{vendorarch}
    (Closes: #752815)

 -- gregor herrmann <gregoa@debian.org>  Sat, 02 Aug 2014 19:20:45 +0200

stfl (0.22-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Convert Ruby build system to dh_ruby, to build for Ruby 1.9/2.0.
    (Closes: #722382)

 -- Christian Hofstaedtler <zeha@debian.org>  Wed, 12 Feb 2014 02:06:19 +0100

stfl (0.22-1) unstable; urgency=low

  * New upstream version:
    - Fix widget overflows if multi-column characters are entered
      (Closes: #603276).
    - Fix that richtext is not multi-column caracters aware
      (Closes: #603334).
    - Fix that stfl_modify takes long time if a form has many widgets
      (Closes: #604770).
  * libstfl-dev: add missing strict dependency on libstfl0 (Closes: #646199).
  * libstfl0: do not depend on libncursesw5-dev (Closes: #646201).
    - Thanks Sven Joachim for both, this should've been noticed way earlier.
  * Convert package to dh_python2 (Closes: #617072).
  * Bump standards version, no changes needed.
  * Add ${misc:Depends} to binary packages where it was missing.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Bump minor version in symbol files and link file.

 -- Nico Golde <nion@debian.org>  Tue, 25 Oct 2011 16:01:40 +0200

stfl (0.21-2) unstable; urgency=low

  * Adapt package to build with ruby 1.9.1 rather than 1.9 (Closes: #565844).

 -- Nico Golde <nion@debian.org>  Tue, 19 Jan 2010 10:18:07 +0100

stfl (0.21-1) unstable; urgency=low

  * New upstream release
    - allows overwriting key values for page up/down (Closes: #479650).
    - introduce libstfl0 as upstream builds a shared library now.
    - Added libstfl0.symbols.
  * debian/rules:
    - use py_sitename macro to copy all python modules in to the right path.
    - include /usr/share/python/python.mk (needed to build with Python 2.6).
    - additionally adjust debian/python-stfl.install to install all python
      modules into /usr/lib/pythonX.Y/*-packages.
      Thanks Alessio Treglia (Closes: #528715).
  * Bump policy version, no changes needed.
  * Fix duplicate short descriptions.
  * Remove Michael Mende from uploaders as it seems he is not interested
    in this package anymore. Thanks a lot for your previous work!

 -- Nico Golde <nion@debian.org>  Tue, 22 Sep 2009 12:48:17 +0200

stfl (0.20-2) unstable; urgency=low

  * Add pkg config file to -dev package (Closes: #528394)

 -- Nico Golde <nion@debian.org>  Tue, 12 May 2009 22:58:49 +0200

stfl (0.20-1) unstable; urgency=low

  * New upstream release.
  * Bump policy version, no changes needed.
  * We have a ruby section now, changed section fields for
    ruby related packages.
  * Adjust copyright years.
  * Remove section for libstfl-dev as this is inherited from the
    source package.

 -- Nico Golde <nion@debian.org>  Mon, 27 Apr 2009 16:24:58 +0200

stfl (0.19-1) unstable; urgency=low

  * New upstream release.
  * Bump policy version to 3.8.0, no changes needed.
  * Bump debhelper compat level.
  * Fix spelling error in python-stfl description (python->Python).

 -- Nico Golde <nion@debian.org>  Mon, 27 Apr 2009 16:10:53 +0200

stfl (0.18-3) unstable; urgency=low

  * Apply patch by Kusanagi Kouichi to prevent a segfault
    if the root widget was replaced (Closes: #476256).
  * Bump compat level to 6 as it is the default now.
  * Fix spelling-error-in-description python Python by writing
    python in lowercase letters in the description.

 -- Nico Golde <nion@debian.org>  Thu, 01 May 2008 14:08:01 +0200

stfl (0.18-2) unstable; urgency=low

  * Change ruby library path for ruby1.9 as it changed with the upload
    of ruby 1.9.0.0-1 (Closes: #458714).


=== debian/control ===
Source: stfl
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper-compat (= 13),
               gem2deb,
               libncurses-dev,
               swig,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Section: libdevel
XS-Ruby-Versions: all
Homepage: http://www.clifford.at/stfl/
Vcs-Browser: https://salsa.debian.org/debian/stfl
Vcs-Git: https://salsa.debian.org/debian/stfl.git

Package: libstfl0
Section: libs
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: structured terminal forms language/library
 stfl is a library which implements a curses-based widget set for text
 terminals.
 .
 This package contains the shared library for libstfl.

Package: libstfl-dev
Architecture: any
Depends: libncurses-dev,
         libstfl0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: development files for libstfl
 stfl is a library which implements a curses-based widget set for text
 terminals.
 .
 This package contains the development files required to
 build software that uses libstfl.

Package: libstfl-perl
Section: perl
Architecture: any
Depends: ${misc:Depends},
         ${perl:Depends},
         ${shlibs:Depends},
Description: Perl bindings for the structured terminal forms language/library
 stfl is a library which implements a curses-based widget set for text
 terminals.
 .
 This package contains the perl bindings to libstfl.

Package: libstfl-ruby1.8
Section: oldlibs
Architecture: any
Depends: libstfl-ruby,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Ruby 1.8 bindings for the structured terminal forms language/library
 stfl is a library which implements a curses-based widget set for text
 terminals.
 .
 This is a transitional package and can be safely removed.

Package: libstfl-ruby1.9.1
Section: oldlibs
Architecture: any
Depends: libstfl-ruby,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Ruby 1.9.1 bindings for the structured terminal forms language/library
 stfl is a library which implements a curses-based widget set for text
 terminals.
 .
 This is a transitional package and can be safely removed.

Package: libstfl-ruby
Section: ruby
Architecture: any
Depends: ${misc:Depends},
         ${ruby:Depends},
         ${shlibs:Depends},
X-DhRuby-Root: ruby
Description: Ruby bindings for the structured terminal forms language/library
 stfl is a library which implements a curses-based widget set for text
 terminals.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

MAKE_DESTDIR        := $(CURDIR)/debian/tmp
MAKE_FOUND_INTERPR  := FOUND_PERL5=0 FOUND_SWIG=1 FOUND_SPL=0 FOUND_RUBY=0 FOUND_PYTHON=0
MAKE_INSTALL_TARGET := DESTDIR=$(MAKE_DESTDIR) prefix=/usr
CFLAGS += -fPIC

include /usr/share/dpkg/architecture.mk
PERL_VERSION := $(shell perl -MConfig -e 'print $$Config{version}')
PERL_ARCHLIB := $(shell perl -I/usr/lib/$(DEB_HOST_MULTIARCH)/perl/cross-config-$(PERL_VERSION) -MConfig -e 'print $$Config{vendorarch}')

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp:
	dh_testdir

	$(MAKE) $(MAKE_FOUND_INTERPR)
	# perl
	test ! -f perl5/Makefile || $(MAKE) -C perl5 clean
	cd perl5 && swig -perl5 stfl.i && perl Makefile.PL INSTALLDIRS=vendor
	$(MAKE) -C perl5
	# ruby
	dh_ruby --build

	touch $@

install: build
	dh_testdir
	dh_testroot
	$(MAKE) $(MAKE_INSTALL_TARGET) $(MAKE_FOUND_INTERPR)  install
	# perl
	$(MAKE) -C perl5 install DESTDIR=$(MAKE_DESTDIR) PREFIX=/usr
	sed -e 's;@PERL_ARCHLIB@;$(PERL_ARCHLIB);g' debian/libstfl-perl.install.in > debian/libstfl-perl.install
	# ruby
	dh_ruby --install

clean: $(addprefix clean-ruby-, $(RUBY_VERSIONS))
	dh_testdir
	dh_testroot
	rm -f build-stamp*
	# ruby
	dh_ruby --clean
	# perl
	rm -f debian/libstfl-perl.install

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean
	rm -rf debian/tmp

	dh_clean

binary-indep: build install
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples -plibstfl-dev example.c example.stfl
	dh_install
	dh_installman
	dh_link
	dh_fixperms
	dh_strip
	dh_compress
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_perl
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch

=== debian/watch ===
version=3
https://www.clifford.at/stfl/stfl-(.*)\.tar\.gz
